diff --git a/pkg/virt-handler/hotplug-disk/mount_test.go b/pkg/virt-handler/hotplug-disk/mount_test.go
index 66bae2924..5bcc3995f 100644
--- a/pkg/virt-handler/hotplug-disk/mount_test.go
+++ b/pkg/virt-handler/hotplug-disk/mount_test.go
@@ -843,14 +828,17 @@ var _ = Describe("HotplugVolume volumes", func() {
 			hotplugDiskManager:   hotplugdisk.NewHotplugDiskWithOptions(tempDir),
 		}
 
-		deviceBasePath = func(sourceUID types.UID) string {
-			return filepath.Join(tempDir, string(sourceUID), "volumes")
+		deviceBasePath = func(podUID types.UID) (*safepath.Path, error) {
+			return newDir(tempDir, string(podUID), "volumes")
 		}
-		statCommand = func(fileName string) ([]byte, error) {
-			return []byte("6,6,0777,block special file"), nil
+		statSourceDevice = func(fileName *safepath.Path) (os.FileInfo, error) {
+			return fakeStat(true, 0777, 123456), nil
 		}
-		cgroupsBasePath = func() string {
-			return tempDir
+		statDevice = func(fileName *safepath.Path) (os.FileInfo, error) {
+			return fakeStat(true, 0777, 123456), nil
+		}
+		cgroupsBasePath = func() (*safepath.Path, error) {
+			return tmpDirSafe, nil
 		}
 		isolationDetector = func(path string) isolation.PodIsolationDetector {
 			return &mockIsolationDetector{
@@ -866,7 +854,8 @@ var _ = Describe("HotplugVolume volumes", func() {
 		mountCommand = orgMountCommand
 		unmountCommand = orgUnMountCommand
 		isMounted = orgIsMounted
-		statCommand = orgStatCommand
+		statSourceDevice = orgStatSourceCommand
+		statDevice = orgStatCommand
 		cgroupsBasePath = orgCgroupsBasePath
 		mknodCommand = orgMknodCommand
 		isBlockDevice = orgIsBlockDevice
@@ -902,19 +891,16 @@ var _ = Describe("HotplugVolume volumes", func() {
 			},
 		})
 		vmi.Status.VolumeStatus = volumeStatuses
-		deviceBasePath = func(sourceUID types.UID) string {
-			return filepath.Join(tempDir, string(sourceUID), "volumeDevices")
+		deviceBasePath = func(podUID types.UID) (*safepath.Path, error) {
+			return newDir(tempDir, string(podUID), "volumeDevices")
 		}
-		blockDevicePath := filepath.Join(tempDir, string(sourcePodUID), "volumeDevices", "blockvolume")
-		fileSystemPath := filepath.Join(tempDir, string(sourcePodUID), "volumes", "disk.img")
-		By(fmt.Sprintf("Creating block path: %s", blockDevicePath))
-		err = os.MkdirAll(blockDevicePath, 0755)
+		blockDevicePath, err := newDir(tempDir, string(sourcePodUID), "volumeDevices", "blockvolume")
 		Expect(err).ToNot(HaveOccurred())
-		By(fmt.Sprintf("Creating filesystem path: %s", fileSystemPath))
-		err = os.MkdirAll(fileSystemPath, 0755)
+		fileSystemPath, err := newDir(tempDir, string(sourcePodUID), "volumes")
 		Expect(err).ToNot(HaveOccurred())
 
-		deviceFile := filepath.Join(blockDevicePath, "blockvolumefile")
+		deviceFile, err := newFile(unsafepath.UnsafeAbsolute(blockDevicePath.Raw()), "blockvolumefile")
+		Expect(err).ToNot(HaveOccurred())
 		slicePath := "slice"
 		m.podIsolationDetector = &mockIsolationDetector{
 			slice: slicePath,
@@ -924,37 +910,41 @@ var _ = Describe("HotplugVolume volumes", func() {
 		allowFile := filepath.Join(tempDir, slicePath, "devices.allow")
 		listFile := filepath.Join(tempDir, slicePath, "devices.list")
 		denyFile := filepath.Join(tempDir, slicePath, "devices.deny")
-		_, err := os.Create(allowFile)
+		_, err = os.Create(allowFile)
 		Expect(err).ToNot(HaveOccurred())
 		_, err = os.Create(denyFile)
 		Expect(err).ToNot(HaveOccurred())
 		_, err = os.Create(listFile)
 		Expect(err).ToNot(HaveOccurred())
-		err = ioutil.WriteFile(deviceFile, []byte("test"), 0644)
+		err = ioutil.WriteFile(unsafepath.UnsafeAbsolute(deviceFile.Raw()), []byte("test"), 0644)
 		Expect(err).ToNot(HaveOccurred())
 
-		sourcePodBasePath = func(podUID types.UID) string {
+		sourcePodBasePath = func(podUID types.UID) (*safepath.Path, error) {
 			if podUID == sourcePodUID {
-				return blockDevicePath
+				return blockDevicePath, nil
 			}
-			return fileSystemPath
+			return fileSystemPath, nil
 		}
 		findMntByVolume = func(volumeName string, pid int) ([]byte, error) {
-			return []byte(fmt.Sprintf(findmntByVolumeRes, "filesystemvolume", fileSystemPath)), nil
+			return []byte(fmt.Sprintf(findmntByVolumeRes, "filesystemvolume", unsafepath.UnsafeAbsolute(fileSystemPath.Raw()))), nil
 		}
 
-		diskFile := filepath.Join(fileSystemPath, "disk.img")
-		_, err = os.Create(diskFile)
+		diskFile, err := newFile(unsafepath.UnsafeAbsolute(fileSystemPath.Raw()), "disk.img")
 		Expect(err).ToNot(HaveOccurred())
-		mknodCommand = func(deviceName string, major, minor int64, blockDevicePermissions string) ([]byte, error) {
-			Expect(os.MkdirAll(deviceName, 0755)).To(Succeed())
-			return []byte("Yay"), nil
+		mknodCommand = func(basePath *safepath.Path, deviceName string, dev uint64, blockDevicePermissions os.FileMode) error {
+			_, err := newFile(unsafepath.UnsafeAbsolute(basePath.Raw()), deviceName)
+			Expect(err).ToNot(HaveOccurred())
+			return nil
 		}
+
 		blockVolume := filepath.Join(targetPodPath, "blockvolume")
 		targetFilePath := filepath.Join(targetPodPath, "filesystemvolume.img")
-		mountCommand = func(sourcePath, targetPath string) ([]byte, error) {
-			Expect(sourcePath).To(Equal(filepath.Join(fileSystemPath, "disk.img")))
-			Expect(targetPath).To(Equal(targetFilePath))
+		isBlockDevice = func(path *safepath.Path) (bool, error) {
+			return strings.Contains(unsafepath.UnsafeAbsolute(path.Raw()), "blockvolume"), nil
+		}
+		mountCommand = func(sourcePath, targetPath *safepath.Path) ([]byte, error) {
+			Expect(unsafepath.UnsafeRelative(sourcePath.Raw())).To(Equal(unsafepath.UnsafeAbsolute(diskFile.Raw())))
+			Expect(unsafepath.UnsafeAbsolute(targetPath.Raw())).To(Equal(targetFilePath))
 			return []byte("Success"), nil
 		}
 		err = m.Mount(vmi)
@@ -969,6 +959,7 @@ var _ = Describe("HotplugVolume volumes", func() {
 					TargetFile: blockVolume,
 				},
 			},
+			UsesSafePaths: true,
 		}
 		expectedBytes, err := json.Marshal(record)
 		Expect(err).ToNot(HaveOccurred())
@@ -1005,12 +996,8 @@ var _ = Describe("HotplugVolume volumes", func() {
 	})
 
 	It("unmountAll should cleanup regardless of vmi volumestatuses", func() {
-		log.DefaultLogger().Infof("tempdir: %s", tempDir)
 		sourcePodUID := types.UID("klmno")
 		volumeStatuses := make([]v1.VolumeStatus, 0)
-		mknodCommand = func(deviceName string, major, minor int64, blockDevicePermissions string) ([]byte, error) {
-			return []byte("Yay"), nil
-		}
 		volumeStatuses = append(volumeStatuses, v1.VolumeStatus{
 			Name: "permanent",
 		})
@@ -1037,20 +1024,17 @@ var _ = Describe("HotplugVolume volumes", func() {
 			},
 		})
 		vmi.Status.VolumeStatus = volumeStatuses
-		deviceBasePath = func(sourceUID types.UID) string {
-			return filepath.Join(tempDir, string(sourceUID), "volumeDevices")
+		deviceBasePath = func(podUID types.UID) (*safepath.Path, error) {
+			return newDir(tempDir, string(podUID), "volumeDevices")
 		}
-		blockDevicePath := filepath.Join(tempDir, string(sourcePodUID), "volumeDevices", "blockvolume")
-		fileSystemPath := filepath.Join(tempDir, string(sourcePodUID), "volumes")
-		err = os.MkdirAll(blockDevicePath, 0755)
+		blockDevicePath, err := newDir(tempDir, string(sourcePodUID), "volumeDevices", "blockvolume")
 		Expect(err).ToNot(HaveOccurred())
-		err = os.MkdirAll(fileSystemPath, 0755)
+		fileSystemPath, err := newDir(tempDir, string(sourcePodUID), "volumes")
+		Expect(err).ToNot(HaveOccurred())
+		deviceFile, err := newFile(unsafepath.UnsafeAbsolute(blockDevicePath.Raw()), "blockvolumefile")
+		Expect(err).ToNot(HaveOccurred())
+		err = ioutil.WriteFile(unsafepath.UnsafeAbsolute(deviceFile.Raw()), []byte("test"), 0644)
 		Expect(err).ToNot(HaveOccurred())
-		findMntByVolume = func(volumeName string, pid int) ([]byte, error) {
-			return []byte(fmt.Sprintf(findmntByVolumeRes, "filesystemvolume", fileSystemPath)), nil
-		}
-
-		deviceFile := filepath.Join(blockDevicePath, "file")
 		slicePath := "slice"
 		m.podIsolationDetector = &mockIsolationDetector{
 			slice: slicePath,
@@ -1060,28 +1044,39 @@ var _ = Describe("HotplugVolume volumes", func() {
 		allowFile := filepath.Join(tempDir, slicePath, "devices.allow")
 		listFile := filepath.Join(tempDir, slicePath, "devices.list")
 		denyFile := filepath.Join(tempDir, slicePath, "devices.deny")
-		_, err := os.Create(allowFile)
+		_, err = os.Create(allowFile)
 		Expect(err).ToNot(HaveOccurred())
 		_, err = os.Create(denyFile)
 		Expect(err).ToNot(HaveOccurred())
 		_, err = os.Create(listFile)
 		Expect(err).ToNot(HaveOccurred())
-		err = ioutil.WriteFile(deviceFile, []byte("test"), 0644)
+		err = ioutil.WriteFile(unsafepath.UnsafeAbsolute(deviceFile.Raw()), []byte("test"), 0644)
 		Expect(err).ToNot(HaveOccurred())
-		sourcePodBasePath = func(podUID types.UID) string {
+		sourcePodBasePath = func(podUID types.UID) (*safepath.Path, error) {
 			if podUID == sourcePodUID {
-				return blockDevicePath
+				return blockDevicePath, nil
 			}
-			return fileSystemPath
+			return fileSystemPath, nil
 		}
-		diskFile := filepath.Join(fileSystemPath, "disk.img")
-		_, err = os.Create(diskFile)
+		findMntByVolume = func(volumeName string, pid int) ([]byte, error) {
+			return []byte(fmt.Sprintf(findmntByVolumeRes, "filesystemvolume", unsafepath.UnsafeAbsolute(fileSystemPath.Raw()))), nil
+		}
+
+		diskFile, err := newFile(unsafepath.UnsafeAbsolute(fileSystemPath.Raw()), "disk.img")
 		Expect(err).ToNot(HaveOccurred())
+		mknodCommand = func(basePath *safepath.Path, deviceName string, dev uint64, blockDevicePermissions os.FileMode) error {
+			_, err := newFile(unsafepath.UnsafeAbsolute(basePath.Raw()), deviceName)
+			Expect(err).ToNot(HaveOccurred())
+			return nil
+		}
 		blockVolume := filepath.Join(targetPodPath, "blockvolume")
 		targetFilePath := filepath.Join(targetPodPath, "filesystemvolume.img")
-		mountCommand = func(sourcePath, targetPath string) ([]byte, error) {
-			Expect(sourcePath).To(Equal(filepath.Join(fileSystemPath, "disk.img")))
-			Expect(targetPath).To(Equal(targetFilePath))
+		isBlockDevice = func(path *safepath.Path) (bool, error) {
+			return strings.Contains(unsafepath.UnsafeAbsolute(path.Raw()), "blockvolume"), nil
+		}
+		mountCommand = func(sourcePath, targetPath *safepath.Path) ([]byte, error) {
+			Expect(unsafepath.UnsafeRelative(sourcePath.Raw())).To(Equal(unsafepath.UnsafeAbsolute(diskFile.Raw())))
+			Expect(unsafepath.UnsafeAbsolute(targetPath.Raw())).To(Equal(targetFilePath))
 			return []byte("Success"), nil
 		}
 		err = m.Mount(vmi)
@@ -1096,6 +1091,7 @@ var _ = Describe("HotplugVolume volumes", func() {
 					TargetFile: blockVolume,
 				},
 			},
+			UsesSafePaths: true,
 		}
 		expectedBytes, err := json.Marshal(record)
 		Expect(err).ToNot(HaveOccurred())
@@ -1142,3 +1138,67 @@ func (i *mockIsolationDetector) Allowlist(_ []string) isolation.PodIsolationDete
 func (i *mockIsolationDetector) AdjustResources(_ *v1.VirtualMachineInstance) error {
 	return nil
 }
+
+func newFile(baseDir string, elems ...string) (*safepath.Path, error) {
+	targetPath := filepath.Join(append([]string{baseDir}, elems...)...)
+	err := os.MkdirAll(filepath.Dir(targetPath), os.ModePerm)
+	if err != nil {
+		return nil, err
+	}
+	f, err := os.Create(targetPath)
+	if err != nil {
+		return nil, err
+	}
+	f.Close()
+	return safepath.JoinAndResolveWithRelativeRoot(baseDir, elems...)
+}
+
+func newDir(baseDir string, elems ...string) (*safepath.Path, error) {
+	targetPath := filepath.Join(append([]string{baseDir}, elems...)...)
+	err := os.MkdirAll(targetPath, os.ModePerm)
+	if err != nil {
+		return nil, err
+	}
+	return safepath.JoinAndResolveWithRelativeRoot(baseDir, elems...)
+}
+
+func fakeStat(isDevice bool, mode os.FileMode, dev uint64) os.FileInfo {
+	return fakeFileInfo{isDevice: isDevice, mode: mode, dev: dev}
+}
+
+type fakeFileInfo struct {
+	isDevice bool
+	mode     os.FileMode
+	dev      uint64
+}
+
+func (f fakeFileInfo) Name() string {
+	//TODO implement me
+	panic("implement me")
+}
+
+func (f fakeFileInfo) Size() int64 {
+	//TODO implement me
+	panic("implement me")
+}
+
+func (f fakeFileInfo) Mode() fs.FileMode {
+	if f.isDevice {
+		return f.mode | fs.ModeDevice
+	}
+	return f.mode
+}
+
+func (f fakeFileInfo) ModTime() time.Time {
+	//TODO implement me
+	panic("implement me")
+}
+
+func (f fakeFileInfo) IsDir() bool {
+	//TODO implement me
+	panic("implement me")
+}
+
+func (f fakeFileInfo) Sys() interface{} {
+	return &syscall.Stat_t{Rdev: f.dev}
+}
-- 
2.37.1


